package com.tptj.demo.hg.controller.register;

import com.fanruan.api.net.NetworkKit;
import com.fr.decision.webservice.Response;
import com.fr.decision.webservice.annotation.LoginStatusChecker;
import com.fr.decision.webservice.utils.WebServiceUtils;
import com.fr.third.springframework.http.MediaType;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-03-22
 * 这个demo用于讲解spring Controller 的常见写法
 **/
@Controller
/**
 * http(s):ip:port/webroot/decision/usr/info/Anna
 */
@RequestMapping(value = "/usr/info/{username}")
/**
 * 不需要校验登录状态，
 */
@LoginStatusChecker(required = false)
public class SimpleServer {

    @RequestMapping(value = "/simple", method = RequestMethod.GET, produces = MediaType.TEXT_HTML_VALUE)
    @ResponseBody
    public String page( @PathVariable("username") String username ) throws Exception {
        Map<String, Object> param = new HashMap<String, Object>(1);
        param.put("username",username);
        return WebServiceUtils.parseWebPageResourceSafe(
                "/com/tptj/demo/hg/controller/register/hello.html", param);
    }

    @RequestMapping(value = "/base", method = RequestMethod.GET)
    @ResponseBody
    @LoginStatusChecker
    public Response getInfo( @RequestParam(value = "key", defaultValue = "hello") String key ) throws Exception {
        DataBean data = new DataBean();
        data.setKey(key);
        data.setVal(123);
        data.setTime(new Date());
        data.setEnable(true);
        List<SubBean> list = new ArrayList<SubBean>(2);
        list.add(new SubBean().key("A"));
        list.add(new SubBean().key("B"));
        data.setList(list);
        Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("A","1");
        map.put("B","2");
        data.setData(map);
        return Response.ok(data);
    }

    @RequestMapping(value = "/base", method = RequestMethod.POST)
    @ResponseBody
    public Response setInfo( @RequestBody DataBean bean ) throws Exception {
        return Response.ok(bean);
    }

    @RequestMapping(value = "/redirect", method = RequestMethod.GET)
    @ResponseBody
    public Response redirect( HttpServletRequest request, HttpServletResponse response ) throws Exception{
        String key = NetworkKit.getHTTPRequestParameter(request,"key");
        response.sendRedirect("http://localhost:8075/webroot/decision?key="+key);
        return null;
    }

    @RequestMapping(value = "/redirect2", method = RequestMethod.GET)
    public void redirect2( HttpServletRequest request, HttpServletResponse response ) throws Exception{
        String key = NetworkKit.getHTTPRequestParameter(request,"key");
        response.sendRedirect("http://localhost:8075/webroot/decision?key="+key);
    }
}
